/*
	ȒPȃVA|[gʐM

*/

#include "StdAfx.h"

#include <stdio.h>
#include <stdlib.h>
#include <Windows.h>

#include "TinyCom.h"


// RXgN^

TinyCom::TinyCom(TCHAR *comname)
{
	if (_tcslen(comname) > 5) {
		comDevice[0] = '\0';
	} else {
		//   "COM?" g COM9܂łgȂ
		//   "\\.\COM??"gCOM10ȏgB
		//   ĆAGXP[v̂ "\\\\.\\COM??"ɂ邱
		_tcscpy_s(comDevice, _T("\\\\.\\"));
		_tcscat_s(comDevice, comname);
	}

	hComPort = INVALID_HANDLE_VALUE;
}

// fXgN^

TinyCom::~TinyCom(void)
{
	Close();
}


/* COMnh̎M^CAEgݒ */

BOOL TinyCom::SetRecvTimeout(int timeout)
{
	COMMTIMEOUTS timeouts;

	GetCommTimeouts(hComPort, &timeouts);
	// -1,0,0,0,500

	timeouts.ReadIntervalTimeout = 0;
	timeouts.ReadTotalTimeoutMultiplier = 0;
	timeouts.ReadTotalTimeoutConstant = timeout;
	SetCommTimeouts(hComPort, &timeouts);

	return TRUE;
}

/* COMnh̑M^CAEgݒ */

BOOL TinyCom::SetSendTimeout(int timeout)
{
	COMMTIMEOUTS timeouts;

 	GetCommTimeouts(hComPort, &timeouts);
	// -1,0,0,0,500

	timeouts.WriteTotalTimeoutMultiplier = 0;
	timeouts.WriteTotalTimeoutConstant = timeout;
	SetCommTimeouts(hComPort, &timeouts);

	return TRUE;
}

/* Mobt@̃p[W */

void TinyCom::PurgeSendRecvBuf(void)
{
	PurgeComm(hComPort, PURGE_TXCLEAR | PURGE_RXCLEAR);
}


/* COM|[g̃N[Y */

void TinyCom::Close(void)
{
	if (hComPort != INVALID_HANDLE_VALUE) {
		CloseHandle(hComPort);
		hComPort = INVALID_HANDLE_VALUE;
	}
}

/* COM|[gw葬xŃI[v(8bit mpeB 1stopbit Œ)
 */


BOOL TinyCom::Open(int bps)
{
	DCB dcb;

	// I[vꍇɃNȂ悤ɁAN[YĂ܂
	Close();

	hComPort = CreateFile(comDevice, GENERIC_WRITE|GENERIC_READ,
										0,
										NULL,
										OPEN_EXISTING,
										0,
										NULL);
	if (hComPort == INVALID_HANDLE_VALUE) {
		return FALSE;
	}

	if (GetCommState(hComPort, &dcb) != TRUE) {
		return FALSE;
	}

	dcb.DCBlength		 = sizeof(dcb);
	dcb.BaudRate		= bps;
	dcb.fBinary			= TRUE;
	dcb.ByteSize		= 8;				// 8bit
	dcb.Parity			= NOPARITY;			// mpeB
	dcb.StopBits		= ONESTOPBIT;		// 1 stop bit
	dcb.XonChar			= 0x11;
	dcb.XoffChar		= 0x13;				//  XonCharXoffCharSetCommState()s邽
	dcb.fOutxCtsFlow	= FALSE;
	dcb.fOutxDsrFlow	= FALSE;
	dcb.fOutX			= FALSE;
	dcb.fInX			= FALSE;
	dcb.fDsrSensitivity	= FALSE;
	dcb.fDtrControl		= DTR_CONTROL_ENABLE;
	dcb.fRtsControl		= RTS_CONTROL_ENABLE;
	dcb.fAbortOnError	= FALSE;			// G[~߂Ȃ
	if (SetCommState(hComPort, &dcb) != TRUE) {
		return FALSE;
	}

	// Ƃ肠MƂ^CAEg1bɐݒ
	SetRecvTimeout(1000);
	SetSendTimeout(1000);

	return TRUE;
}


/* COM|[gɎwoCgM
   M^CAEgOpenCom()ftHg1bƉ肵Ă
*/

BOOL TinyCom::Send(BYTE *data, int size)
{
	DWORD dwBytes = 0;
	BOOL ret;

	if ((ret = WriteFile(hComPort, data, size, &dwBytes, NULL)) != TRUE) {
		return FALSE;
	}
	if (size != dwBytes) {
		return FALSE;
	}
	return TRUE;
}

/* COM|[g1oCgM
   M^CAEgOpenCom()ftHg1bƉ肵Ă
*/

BOOL TinyCom::SendByte(BYTE data)
{
	DWORD dwBytes = 0;

	if (WriteFile(hComPort, &data, 1, &dwBytes, NULL) != TRUE) {
		return FALSE;
	}
	if (dwBytes != 1) {
		return FALSE;
	}
	return TRUE;
}

/* COM|[g LittleEndian WORDl w 𑗐M
   M^CAEgOpenCom()ftHg1bƉ肵Ă
*/

BOOL TinyCom::SendWord(WORD w)
{
	DWORD dwBytes = 0;

	if (WriteFile(hComPort, &w, 2, &dwBytes, NULL) != TRUE) {
		return FALSE;
	}
	if (dwBytes != 2) {
		return FALSE;
	}
	return TRUE;
}

/* COM|[gwoCgM
	timeout ms ȓɎMłȂ return FALSE
	woCgMł return TRUE
*/

BOOL TinyCom::Recv(BYTE *data, int size, int timeout)
{
	DWORD dwBytes = 0;

	SetRecvTimeout(timeout);

	if (ReadFile(hComPort, data, size, &dwBytes, NULL) != TRUE) {
		return FALSE;
	}
	if (dwBytes != size) {
		return FALSE;
	}

	return TRUE;
}


/* COM|[g1oCgM
	timeout ms ȓɎMłȂ return -1;
	Mł return data & 0xff;
*/

int TinyCom::RecvByte(int timeout)
{
	BYTE data;
	DWORD dwBytes = 0;

	SetRecvTimeout(timeout);

	if (ReadFile(hComPort, &data, 1, &dwBytes, NULL) != TRUE) {
		return -1;
	}
	if (dwBytes != 1) {
		return -1;
	}

	return data & 0xff;
}

/* COM|[g2oCgM
	timeout ms ȓɎMłȂ return -1;
	MłA M̂LittleEndianWORDlƌȂĂreturn
*/

int TinyCom::RecvWord(int timeout)
{
	DWORD dwBytes = 0;
	BYTE data[2];

	SetRecvTimeout(timeout);

	if (ReadFile(hComPort, &data, 2, &dwBytes, NULL) != TRUE) {
		return -1;
	}
	if (dwBytes != 2) {
		return -1;
	}

	return *(WORD *)&data[0];
}

// end of file
