/*
	R8C Bootmode class  "R8cBm"

	 H8n̂悤BootmodeƌĂł܂A
	   M16C Iɂ͕WVAo̓[h(Standard Serial I/O mode) 

	2007/07/02 yza
		ЂȂ܂
	2007/07/03 yza
		قڏBH
		R8C/13, 25 œmFB
	2007/07/09 yza
		VA|[gnhO TinyComɕ

0x70 [hXe[^XWX^ R}h
 SRD, SRD12oCgԂĂ
 SRD  bit7   V[PTXe[^X    1:READY       0:BUSY
      bit6   (reserved)
      bit5   C[YXe[^X      1:G[I  0:I
      bit4   vOXe[^X    1:G[I  0:I
      bit3   ubNXe[^XAt^vO    1:G[I  0:I
             ibit3M16Ĉ݁H)
      bit2   (reserved)
      bit1   (reserved)
      bit0   (reserved)
 SRD1 bit7   u[gXVς݃rbg    1:XVς    0:XV  (RAM_E[h@\)
      bit6   (reserved)
      bit5   (reserved)
      bit4   `FbNTvrbg  1:v        0:sv
      bit3,2 IDƍς݃rbg        00:ƍ
                                     01:ƍsv
                                     10:(reserved)
                                     11:ƍς
      bit1   f[^MTIMEOUT       1:TIMEOUT     0:퓮
      bit0   (reserved)

  d 0x80 0x00 Ԃ
  ID`FbNR}h𑗂́A
     0x80 0x0c  ƍς
     0x80 0x04  ƍsv
  Ԃ

  IDƍsvƁAɐID𑗂Ă󂯕tȂB
  ȂƁAZbgĂ_ŁAdē܂Ń_B
  ̂߁AID`FbNɑ΂ăv[gtH[XA^bN邱Ƃ͎s\ƎvB

0x50 NAXe[^XWX^ R}h
  Ԓl Ȃ
  SRD, SRD1NAB
  q̂悤ɁAIDƍsvԂ̓NAȂB


*/

#include "StdAfx.h"

#include <stdio.h>
#include <stdlib.h>
#include <Windows.h>

#include "TinyCom.h"
#include "R8cBm.h"


// ---------------------------------------------------------------------------

// RXgN^

R8cBm::R8cBm(TCHAR *comname)
{
	tinycom = new TinyCom(comname);
	last_srd = 0;
}

// fXgN^

R8cBm::~R8cBm(void)
{
	delete tinycom;
}




// COM|[g܂9600bpsŃI[vA
// u[g[hmFA57600bpsɐ؂芷
// return TRUE;   57600bpsŃI[v܂܋A
// return FALSE;  COM|[g̓N[YċA

BOOL R8cBm::StartBootMode(void)
{
	WORD ret;

	// ܂57600bpsŃu[g[hł͂Ȃ̂ŁA9600bpsŏn߂

	if (!tinycom->Open(9600)) {
		goto StartBootMode_ErrorReturn;
	}

	tinycom->PurgeSendRecvBuf();

	// }CRrbg[g킹ݏ邽߁A0x0016ȏ㑗
	for (int i = 0; i < 17; i++) {
		tinycom->SendByte(0x00);
		Sleep(20);
	}
	Sleep(100);

	tinycom->SendByte(0xb0);					// 0xb0 (9600bpsɃZbg)M
	Sleep(100);

	// P

	tinycom->SendByte(0xb0);					// 0xb0 (9600bpsɃZbg) M
	Sleep(100);

	// { Send:0xb0 Recv:0xb0 mFׂA
	// łɂPڍsV[PXs݂ŁA}CR57600bpsɑJڂĂ邩Ȃ̂
	// mFȂ

	// 57600bpsɐ؂芷R}h

	tinycom->SendByte(0xb3);					// 0xb3 (57600bpsɃZbg) M
	// { Send:0xb3 Recv:0xb3 mFׂ

	// 57600bpsɐ؂芷
	if (!tinycom->Open(57600)) {
		goto StartBootMode_ErrorReturn;
	}
	Sleep(100);
	tinycom->PurgeSendRecvBuf();

	tinycom->SendByte(0xb3);					// 0xb3 M
	// ŏ͖̉(Ă邩Ȃ̂)
	Sleep(100);
	tinycom->PurgeSendRecvBuf();

	tinycom->SendByte(0xb3);					// 0xb3 M
	// P񖳎
	Sleep(100);
	tinycom->PurgeSendRecvBuf();

	tinycom->SendByte(0xb3);					// 0xb3 M
	if (tinycom->RecvByte(100) != 0xb3) {		// 0xb3AĂ̂100ms܂ő҂
		goto StartBootMode_ErrorReturn;
	}

	// NAXe[^XWX^𑗂Ă݂
	tinycom->SendByte(0x50);
	Sleep(100);

	tinycom->SendByte(0x70);					// 0x70 M
	if ((ret = tinycom->RecvWord(100)) == -1) {	// wordlԂĂ̂100ms܂ő҂
		goto StartBootMode_ErrorReturn;
	}
	last_srd = ret;

	// 0x??80ԂĂOK
	if ((ret & 0xff) == 0x80) {
		return TRUE;
	}

	// ȊO̓G[

StartBootMode_ErrorReturn:
	tinycom->Close();
	return FALSE;
}

// ID`FbNς݂mF

BOOL R8cBm::CheckID(int timeout)
{
	int ret;

	// 0x70 o i[hXe[^XWX^)
	// 0x80 0x0c  IDƍς݂Ȃ̂ return TRUE;
	tinycom->SendByte(0x70);							// 0x70 M
	if ((ret = tinycom->RecvWord(timeout)) == -1) {		// 2oCgAĂ̂҂
		return FALSE;
	}
	if (ret == 0x0c80) {
		return TRUE;		// IDƍς
	}
	return FALSE;
}



// IDƍ

BOOL R8cBm::CompareID(BYTE *id)
{
	BYTE sbuf[5];

	tinycom->PurgeSendRecvBuf();

	// 0xf5 0xdf 0xff 0x00 0x07 M
	// ID 7 oCg M
//	Sleep(5);
	sbuf[0] = 0xf5;	// ID checkR}h
	sbuf[1] = 0xdf;	//   AhX A7-0
	sbuf[2] = 0xff; //   AhX A15-8
	sbuf[3] = 0x00; //   AhX A23-16 (R8C 48KBi܂ł 0x00łƎv)
	sbuf[4] = 0x07;	//   ID 7oCg
	tinycom->Send(sbuf, 5);
	tinycom->Send(id, 7);

	return R8cBm::CheckID(100);
}

// SubNErase

BOOL R8cBm::Erase(void)
{
	BYTE rbuf[10];

	tinycom->PurgeSendRecvBuf();

	if (!R8cBm::CheckID(100)) {
		return FALSE;
	}

	// 0xfb o
	// o[W 8oCgAĂ̂mF
	tinycom->SendByte(0xfb);
	if (tinycom->Recv(rbuf, 8, 100) == -1) {		// 8oCgAĂ̂100ms܂ő҂
		return FALSE;
	}
	// AĂo[Wf[^͊mFȂ

	// 0x50 o (NAXe[^XWX^)
	tinycom->SendByte(0x50);
	Sleep(50);

	// 0x75 o (bNrbg)
	tinycom->SendByte(0x75);
	Sleep(50);

	// 0xa7 0xd0  o (C[Y SAbNubN)
	tinycom->SendWord(0xd0a7);

	// 
	Sleep(100);

	// ID`FbN OKȂ
	// R8C/25 ̏ꍇA 172ms ŉԂĂ
	// f[^V[gƍŒ9b(R8C/25, 13)ƏĂ
	// 5bɂĂ

	return R8cBm::CheckID(5000);
}

// wAhX256oCg

BOOL R8cBm::Write(int addr, BYTE *p)
{
	if (addr & 0xff) {		// 256oCgE`FbN
		return FALSE;
	}

	tinycom->PurgeSendRecvBuf();

	// 0x41 y[W[hR}h
	tinycom->SendByte(0x41);
	// AhX(A7-0͕K0Ȃ̂ŏȂA A15-8, A23-16 2oCg) o
	tinycom->SendWord((WORD)((addr >> 8) & 0xffff));
	// 256oCg̏݃f[^𑗐M
	tinycom->Send(p, 256);

	// ̎_ 0xf0 ԂĂĂG[(AhXُȂ)
	if (tinycom->RecvByte(10) == 0xf0) {
		tinycom->SendByte(0x50);	// NAXe[^XWX^R}h𑗂Ă
		return FALSE;
	}

	// 1oCg݂max 400us(R8C/13,25f[^V[g) * 256 = 103ms
	// ]T 200ms܂ő҂

	return R8cBm::CheckID(200);
}

// wAhX256oCgǂݏo

BOOL R8cBm::Read(int addr, BYTE *p)
{
	if (addr & 0xff) {		// 256oCgE`FbN
		return FALSE;
	}

	tinycom->PurgeSendRecvBuf();

	// 0xff y[WCgR}h
	tinycom->SendByte(0xff);
	// AhX(A7-0͕K0Ȃ̂ŏȂA A15-8, A23-16 2oCg) o
	tinycom->SendWord((WORD)((addr >> 8) & 0xffff));

	// 256oCgԂĂ̂200ms(K)܂ő҂
	return tinycom->Recv(p, 256, 200);
}

// end of file

